﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter;
using Infragistics.DragDrop;
using Infragistics.Controls.Menus;
using Infragistics.Windows.Controls;

namespace XamDataGridToXamDataTreeDragDrop
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void xamDataGrid1_AssigningFieldLayoutToItem(object sender, Infragistics.Windows.DataPresenter.Events.AssigningFieldLayoutToItemEventArgs e)
        {
            FieldLayout resultLayout = new FieldLayout();
            if (e.ParentExpandableFieldRecord == null)
                resultLayout = xamDataGrid1.FieldLayouts["parent"];
            else
                resultLayout = xamDataGrid1.FieldLayouts["child"];
            e.FieldLayout = resultLayout;
        }



        private void DragSource_Drop(object sender, Infragistics.DragDrop.DropEventArgs e)
        {
            if (e.DropTarget is XamDataTreeNodeControl && e.DragSource is CardPanel)
            {
                XamDataTreeNodeControl node = e.DropTarget as XamDataTreeNodeControl;
                Data data = (e.DragSource as CardPanel).Tag as Data;

                if ((node.Node.Data as Data).ChildData == null)
                {
                    (node.Node.Data as Data).ChildData = new ObservableCollection<Data>();
                }
                node.Node.Nodes.Add(new XamDataTreeNode(node.Node.Index + 1, node.Node.Manager, data, false, xamDataTree1.GlobalNodeLayouts[0]));


            }
        }

    }

    public class DataContextProvider
    {
        public DataContextProvider()
        {
            GridData = new ObservableCollection<Data>();
            TreeData = new ObservableCollection<Data>();

            for (int i = 0; i < 10; i++)
            {
                Data data = new Data
                { 
                    ID = i, 
                    Name = "Node: " + i, 
                    ChildData = new ObservableCollection<Data>() 
                };

                for (int j = 0; j < 5; j++)
                {
                    Data d1 = new Data
                    {
                        ID = i * j,
                        Name = "Node: " + i + ":" + j
                    };
                    data.ChildData.Add(d1);
                }
                TreeData.Add(data);
            }

            for (int i = 0; i < 10; i++)
            {
                Data d = new Data
                {
                    ID = i,
                    Name = "Record: " + i,
                    ChildData = new ObservableCollection<Data>()
                };

                for (int j = 0; j < 5; j++)
                {
                    Data d1 = new Data
                    {
                        ID = i * j,
                        Name = "Record: " + i + ":" + j
                    };
                    d.ChildData.Add(d1);
                }
                GridData.Add(d);
            }

        }

        public ObservableCollection<Data> GridData { get; set; }
        public ObservableCollection<Data> TreeData { get; set; }
    }

    public class Data 
    {
        public int ID { get; set; }
        public string Name { get; set; }
        public ObservableCollection<Data> ChildData { get; set; }
    }

}
